sub my_action {
###############

  my ($r,$v2,$v3,$short);

 # header
 print "<script language='javascript'>document.getElementById('hl').innerHTML='set sas3ircu'</script>\n";


# only Illumos
#if ($sys{'auto_os'}=~/Solaris/i)    {
#   print "Select a different sas3ircu is only required on Illumos, not on Solaris";     exit;
#}

 print "SAS3 ircu tool for HBAs with 12G LSI 3008 based chipsets<hr><br>";

 if ($in{'answered'}) { &my_patch; }

 if (-f "/var/web-gui/_my/tools/sas3ircu/sas3ircu")  {
    $r=&exe("/usr/bin/chmod 755 /var/web-gui/_my/tools/sas3ircu/sas3ircu");
    $v3=&exe("/var/web-gui/_my/tools/sas3ircu/sas3ircu");
    $v3=~s/.*Version/Version/s;
    $v3=~s/\n.*//s;

    # patched?
    $r=`cat /var/web-gui/_my/tools/sas3ircu/sas3ircu`;

    if ($r=~/lsc.mpt_sas/s) {
      $short="<b>lsc mpt_sas: patch required for Illumos</b>";
    } else {
      $short="mpt_sas";
    }

    if ($sys{'auto_os'}=~/Solaris/i)    {
      $short="";  # only for Illumos
    }

  $r=`sudo /var/web-gui/_my/tools/sas3ircu/sas3ircu list`;

  print <<EoF;
  <pre><b>Current sas3ircu:</b>
/var/web-gui/_my/tools/sas3ircu/sas3ircu    -> $v3 $short

Sas3ircu is a tool for 12G LSI HBAs to detect the backplane slot for a given WWN disk or to switch on the red alert led.

On Solaris It is suggested that you use the newest sas3ircu for your controller,
On OmniOS/OI you can either use sasircu up to version 5 or you must patch sas3ircu (option, can be unstable)
You can download the sas3ircu tool ex from the Broadcom/ Supermicro/ Thomas Krenn websites and copy to
/var/web-gui/_my/tools/sas3ircu/my_sas3ircu. You can then select and activate it.

Attention:
<font class='font_darkred'>If you select another sas3ircu or if you disable sas3ircu to use the driver internal detection
then your controller number may differ and you must then recreate a map. Use a printout of your old map to re-create a map
with disks at the same slot but with a different controller id.

If you use 6G and 12G LSI HBAs you must either use a working sas2ircu and sas3ircu or
you must set both to none, otherwise controller numbers are wrongly detected !!</font></font>


current sas3ircu list:<hr> $r
</pre>
EoF

}  else {
   print "<br>sas3ircu not found, please select or download the sas3ircu tool for your HBA from the Broadcom/SuperMicro/Thomas Krenn website <br>and upload the file via WinSCP to the appliance<br><br>";
   print "<font class='font_darkred'>If you use 6G and 12G LSI HBAs you must either use a working sas2ircu and sas3ircu or<br>";
   print "you must set both to none, otherwise controller numbers are wrongly detected !!</font><br><br>";
}

if (!($sys{'auto_os'}=~/Solaris/i))    {
 if ($short=~/lsc/) {
   &ask('begin');
   print "Only patch sas3ircu on Illumos based systems if you get the message 'SAS3IRCU: No Controllers Found.'<br><br>";
   &ask('hidden','copy','0');
   &ask('confirm','I want to patch sas3ircu','I patch sas3ircu on my own risk');
   &log_end;
   print "<br><br><br>";
   exit;
 }
}

# otherwise select a different one
$t="";
if (-f "/var/web-gui/_my/tools/sas3ircu/my_sas3ircu") {
  $t=",my_sas3ircu";
}

   &ask('begin');
   print "Select another sas3ircu on Illumos based systems if you get an error or problems with detection.'<br><br>";

   if ($sys{'auto_os'}=~/Solaris/i)    {
     &ask('select','Select sas3ircu',"none,default_sol",'default_sol');
   } else {
     &ask('select','Select sas3ircu',"none,default,option-1$t",'default');
   }

   &ask('hidden','copy','1');
   &ask('confirm','I want to select a different sas3ircu','Test the new sasircu prior using it on a production system');
   &log_end;
   print "<br><br><br>";
   exit;



} #/ my_action



##########
sub my_patch {

    print "<br><br>process request, please wait ..<br>";


    if ($in{'copy'}) {
       if ($in{'select'} eq "none")       {  &exe("rm /var/web-gui/_my/tools/sas3ircu/sas3ircu 2>/dev/null");  &reload;  }
       if ($in{'select'} eq "default")    {  &exe("cp /var/web-gui/data/tools/other/ill_3ircu /var/web-gui/_my/tools/sas3ircu/sas3ircu"); }
       if ($in{'select'} eq "default_sol"){  &exe("cp /var/web-gui/data/tools/other/sol3ircu /var/web-gui/_my/tools/sas3ircu/sas3ircu"); }

       if ($in{'select'} eq "option-1")   {  &exe("cp /var/web-gui/data/tools/other/ill_3bircu /var/web-gui/_my/tools/sas3ircu/sas3ircu"); }
       if ($in{'select'} eq "my_sas3ircu"){  &exe("cp //var/web-gui/_my/tools/sas3ircu/my_sas3ircu /var/web-gui/_my/tools/sas3ircu/sas3ircu"); }

       &exe("/usr/bin/chmod 755 /var/web-gui/_my/tools/sas3ircu/sas3ircu");
       &reload;
    }

    #&print_hash(%in);

    my $hex_in = "/var/web-gui/_my/tools/sas3ircu/sas3ircu";
    my $hex_out = "/tmp/sas3ircu";

    my $search='\x28 \x29 \x20 \x66 \x61 \x69 \x6C \x65 \x64 \x0A \x00 \x6C \x73 \x63 \x00 \x6D';
      $search.='\x70 \x74 \x5F \x73 \x61 \x73 \x00 \x2F \x64 \x65 \x76 \x69 \x63 \x65 \x73 \x25';
      $search=~s/ +//gs;        # spaces only for readability

    # 28 29 20 66 61 69 6C 65 64 0A 00 6C 73 63 00 6D       iled? lsc mpt_sa
    # 73 00 2F 64 65 76 69 63 65 73 25 73 3A 64 65 76       s

    my $replace='\x28 \x29 \x20 \x66 \x61 \x69 \x6C \x65 \x64 \x0A \x00 \x6D \x70 \x74 \x5F \x73';
      $replace.='\x61 \x73 \x00 \x6C \x73 \x63 \x00 \x2F \x64 \x65 \x76 \x69 \x63 \x65 \x73 \x25';
      $replace=~s/ +//gs;        # spaces only for readability

    # 28 29 20 66 61 69 6C 65 64 0A 00 6D 70 74 5F 73       () failed? mpt_s
    # 61 73 00 6C 73 63 00 2F 64 65 76 69 63 65 73 25       as lsc


    #use a copy
    #&exe("cp $hex_in $hex_out");


    #patch
    $search=quotemeta($search);
    #$replace=quotemeta($search);

    &exe("rm $hex_out");
    $r=&exe("touch $hex_out");
    $r=&exe("/usr/bin/chmod 777 $hex_out");

    # info
    #print "s: $search<br>";
    #print "R: $replace";

    # perl -0777 -pe "s/\x00\x42\x00\x11/\x00\x42\x00\xf0/g" input > output
    #`perl -0777 -pe "~s/\\x69\\x6C\\x65\\x64\\x0A\\x00\\x6C\\x73\\x63\\x00\\x6D\\x70\\x74\\x5F\\x73\\x61\\x73\\x00\\x2F\\x64\\x65\\x76\\x69\\x63\\x65\\x73\\x25\\x73\\x3A\\x64\\x65\\x76/\x28\x29\x20\x66\x61\x69\x6C\x65\x64\x0A\x00\x6D\x70\x74\x5F\x73\x61\x73\x00\x6C\x73\x63\x00\x2F\x64\x65\x76\x69\x63\x65\x73\x25/;" /var/web-gui/_my/tools/sas3ircu/sas3ircu >/tmp/sas3ircu`;


    # print current
    $r=`sudo $hex_in list`;
    print "<pre>current sas3ircu: <hr>$r</pre>";

    #patch
    `perl -0777 -pe "s/$search/$replace/g" $hex_in >$hex_out`;
    sleep(1);

    print "<br><br>\n\n";
    $r=`$hex_out list`;

    &log_end;

    #check;
    $r=&exe("/usr/bin/chmod 755 /tmp/sas3ircu");
    $r=`sudo /tmp/sas3ircu list 2>&1`;

    if ($r=~/Version/is) {
      print "<pre>check patched sas3ircu: <hr>$r</pre>";
    } else {
      print "<pre>Patch applied with error, sas3ircu not modified!</pre>";
      exit;
    }
    sleep(3);

    &exe("cp $hex_out $hex_in");
    &exe("rm $hex_out");

    sleep (2);
    &reload;

}

###############################################
#end of my script, do not delete the line below
1;
