###############
sub my_action {
###############

 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_create};                   # create this function in a private mylib.pl to replace this action


  my ($var1, $ant, $type,$d);
#  &gethash_sys_poolnames;

# header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='create Pool on $in{'member'}'</script>\n";


# 1. edited
if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
if ($in{'answered'}) { &my_create; }     # form -> create

# 2. are the unused hds?
if ($disk{'all_unused'} eq "") {
  print" no disks available!";
  return;
}


# 2. get form
####################################################################
# create new pool

print "<b>Howto create a pool</b><br><br>A pool consists of one or more vdevs. So first step is always to create a pool from one (the first) vdev<br>";
print "Next step is to extend the pool with more vdevs to increase capacity and performance.<br><br><b>Do not select disks used by your OS!!<br></b>";

if ($in{'autoselect_type'}=~/draid/) {
      print <<EoF;
      <br>
      dRAID is a variant of raidz that provides integrated distributed hot spares which allows for faster resilvering than raidz. A dRAID vdev is constructed from multiple internal raidz groups, <br>
      each with D data devices and P parity devices. These groups are distributed over all of the children in order to fully utilize the available disk performance. This is known as parity declustering <br>
      and it has been an active area of research. This allows a dRAID vdev to be sequentially resilvered, however the fixed stripe width significantly effects both usable capacity and IOPS. <br>
      For example, with the default D=8 and 4k disk sectors the minimum allocation size is 32k.

      Prefer draid with its distributed spare and parity concept only with very many disks (say 30+) and when resilver time is more important than space efficiency.<br>
      Usually a draid pool with less than 200 disks consists of one draid vdev. With more than say 200 disks, prefer several identical draid vdevs. Resilver time is 20-50% of the time of a resilver on a raid-z. <br>
      You cannot add virtual spares after creating the draid vdev because they are distributed into the dRAID vdev!<br><br>

      Minimum number of disks = 2 + redundancylevel + sparedisks. Number of datadisks must be <= number of disks -redundancy level - sparedisks <br><br>
      Estimated draid capacity=(C-S)*(D/D+P)*DS <br>
      C=children number (number of disks-spares) <br>
      S=distributed hot spare number <br>
      D=number of data devices <br>
      DS=disksize of smallest memberdisk  <br>

EoF
}



# form begin
  &ask('begin');

 ## how many disks
 @t=split(/\t/,$disk{'all_unused'});

## type of pool
## one hd
  if (@t > "0")   {   $type="basic"; }

## 2+ hd
  if (@t > 1)     {   $type.=",mirror"; $d="basic"; }

## 2+ hd
  if (@t > 1)     {   $type.=",raidz1,draid1"; $d="basic"; }

## 3+ hd
  if (@t > 2)     {   $type.=",raidz2,draid2"; $d="basic"; }

## 3+ hd
  if (@t > 2)     {   $type.=",raidz3,draid3"; $d="basic"; }     #raidz3 option


  ##type of pool first due autoselect
  $type="[ ---- select carefully // no undo ---- ],$type";
  &ask('autoselect_type',$txt{'first_vdev'},"$type",$in{'autoselect_type'});

  if ($in{'autoselect_type'}=~/draid/) {
        $in{'value_datadisks'}=~s/\D//g; if ($in{'value_datadisks'} eq "") { $in{'value_datadisks'}="8"; }
        $in{'value_spares'}=~s/\D//g;    if ($in{'value_spares'} eq "")    { $in{'value_spares'}="0"; }
        $in{'value_children'}=~s/\D//g;

        &ask('value_datadisks','number of datadisks (default 8 with many disks)',"$in{'value_datadisks'}",'10');
        &ask('value_spares','number of sparedisks (default 0), <br>distributed draid spares cannot be added later',"$in{'value_spares'}",'10');
        &ask('value_children','number of children (check only), <br>can be kept empty',"$in{'value_children'}",'10');
  }

## name of pool
  &ask('value_new','New pool name',"$in{'value_new'}",'30');

#version
  &ask('select_version',"$txt{'pool_version'} (28v5=all platforms, incl. Oracle Solaris)","default,28v5",$in{'select_version'});

# disable features on openzfs
  &ask('checkbox_dis','Disable features</b> for compatibility with former OS releases<br>or backup pools if you care about bugs in Open-ZFS features<b>',"yes","no");


  ## checkboxes unused disks

  &ask('checkbox_hd','Disks',$disk{'all_unused'})


  # allow basic vdev types
  &ask('select_allow','Allow basic vdevs<br></b>A failure of a basic vdev means pool lost<b>','no,yes');

  # atime  not a pool property, cannot be disabled on pool
  # &ask('select_atime','Log last access time, set atime to off for better performance <br>or for single disk pools<b>','off,on');

  &ask('select_ashift','force ashift<br></b>If you get an error about ashift, select auto<b>',"auto,9,10,11,12,13,14,15,16","12");
  &ask('checkbox_res',$txt{'overflow_protect'},"on","on");

&ask('end');

#info about ashift=12
  print "<br><br>All vdevs should have the same ashift to allow a vdev remove or disk replace with newer disks.<br>In most cases best is ashift=12 (4k disks)";
  print "<br><br>";


## info
  print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
  print "$txt{'pool_create_info'}";

print "<br><br>pools:\n";
print "<pre>".&exe("zpool status")."</pre>";
#print &list2table(&zfslib_list_pools('all,header,state,status'));


######################### / form ############################################

} #/ my_action
################



##############################################################################
sub my_create {
################ create pool

   my ($i,@w,$n,$what,$pool,$ver,$opt,$opt1,$children,$draid);

   print "after error messages or warnings, check menu pools for real pool state<br>";

   #name of pool
   $in{'value_new'}=&alltrim($in{'value_new'});            # remove  + spaces +

   # Strict
   $in{'value_new'}=~s/[^a-zA-Z0-9_\.\-:]//g;              # allowed in poolname


   # zraid-n, create only in standalone mode
  # if ($cfg{'select_servermode'} eq "") { $cfg{'select_servermode'}="standalone"; }
  # if (($in{'value_new'}=~/^zraid\-\d/) && ($cfg{'select_servermode'} ne "standalone")) {
   #    &mess("A zraid pool cannot be created in clustermode for security reasons.<br>Switch to standalone in About &gt; Settings to create a zraid-pool and switch back to cluster-failover mode afterwards.");
  # }

   #draid
   # zpool create <pool> draid[<parity>][:<data>d][:<children>c][:<spares>s] <vdevs...>

   # parity - The parity level (1-3). Defaults to one.
   # data - The number of data devices per redundancy group. In general a smaller value of D will increase IOPS, improve the compression ratio, and speed up resilvering at the expense of total usable capacity. Defaults to 8, unless N-P-S is less than 8.
   # children - The expected number of children. Useful as a cross-check when listing a large number of devices. An error is returned when the provided number of children differs.
   # spares - The number of distributed hot spares. Defaults to zero.
   # For example, to create an 11 disk dRAID pool with 4+1 redundancy and a single distributed spare the command would be:

   # zpool create tank draid:4d:1s:11c /dev/sd[a-k]

   #debug
   #&print_hash(%cfg);

   # Tested to work
   #$in{'value_new'}=~s/[^a-zA-Z0-9_\.\-\: \t]//g;          # allowed in poolname

   # Relaxed version of tested.
   # $in{'value_new'}=~s/[^\w:\.\-\s]//g;                  # allowed in poolname

   # http://www.sun.com/bigadmin/features/articles/zfs_overview.jsp notably omits spaces and tabs
   # however they are legal on opensolaris snv134 at least. Perhaps error checking should be left to the
   # command(?)

   #name??
   if ($in{'value_new'} eq "")    { &mess("missing poolname?"); }

   if ($in{'autoselect_type'}=~/\[/)  { &mess("please select a vdev type"); }

   #version
   if ($in{'select_version'}=~/\d+/) {
      $in{'select_version'}=~s/v5//;
      $ver.=" -o version=$in{'select_version'}";

      if ($in{'select_version'}=~/28/) {
         $ver.=" -O version=5";
         if ($in{'autoselect_type'}=~/draid/) { &mess("Pool v28 not possible with draid"); }
      }
   }


   $opt1="";  # always even when encr
   if ($in{'select_ashift'}=~/\d/) {
       $opt2=" -o ashift=$in{'select_ashift'}"
   }

   #disable features;
   $opt="";
   if ($in{'checkbox_dis'}=~/yes/) {
       $opt=" -d";
       if ($in{'autoselect_type'}=~/draid/) { &mess("Disable features not possible with draid"); }
   }

   #atime, not a pool property, cannot be disabled
   #$opt.="  -o atime=$in{'select_atime'}";


   #add opt: aclmode and aclinherit=pass-through

   #crypt
   if ($in{'autoselect_crypt'}  eq "on") {
     if ($in{'value_crypt1pass'} eq "") {                         &mess($txt{'mess_pass_needed'}); }
     if (length($in{'value_crypt1pass'}) < 8) {                   &mess($txt{'mess_minchar'}); }
     if ($in{'value_crypt1pass'} ne $in{'value_crypt2pass'}) {    &mess($txt{'mess_pass_different'}); }
   }


   #get hd-id
   $in{'checkbox_hd'}=~s/[^a-zA-Z0-9\-\_\,\.\+]//gs;        # remove special char from reload
   $in{'checkbox_hd'}=~s/\.\+$//;
   @w = split(/\.\+/,$in{'checkbox_hd'});                   # array of selected disks

#&print_array(@w);

   #number of disks
   $n=@w;

   #type ok?
   #########
     if ($n < 1)  { &mess($txt{'mess_need_disk'}); }

   #basisc
   if ($in{'autoselect_type'} eq "basic") {
       if ($in{'select_allow'} ne "yes") { &mess("Basic vdevs are a security risk as a failure means pool lost.<br>Set allow basic vdevs to yes if you really want basic vdevs."); }
   }

   #mirror
     if (($n < 2) && ($in{'autoselect_type'} eq "mirror"))     { &mess($txt{'mess_mirror'}); }

   #raidz
     if (($n < 2) && ($in{'autoselect_type'} eq "raidz1"))      { &mess($txt{'mess_raidz'}); }
     $in{'autoselect_type'}=~s/raidz1/raidz/;

   #raidz2
     if (($n < 3) && ($in{'autoselect_type'} eq "raidz2"))     { &mess($txt{'mess_raidz2'}); }

   #raidz3
     if (($n < 4) && ($in{'autoselect_type'} eq "raidz3"))     { &mess($txt{'mess_raidz3'}); }

   #draid, min
     if (($n < 3) && ($in{'autoselect_type'} eq "draid1"))     { &mess("not enough disks for this draid, min 3"); }
     if (($n < 4) && ($in{'autoselect_type'} eq "draid2"))     { &mess("not enough disks for this draid, min 4"); }
     if (($n < 5) && ($in{'autoselect_type'} eq "draid3"))     { &mess("not enough disks for this draid, min 5"); }


   #create pool ex.  zpool create -f tank mirror c1d0 c2d0 mirror c3d0 c4d0
   ################################################################

   # 1. hdlist
   ###
     $n=join(" ",@w);  #list of hds: hd1 hd2 ..

   #action
   #######

    if ($in{'autoselect_type'} =~/basic/) {
        $in{'autoselect_type'}="";                                              #basic from form is not a valid type
    }

   # with encryption
   if ($in{'autoselect_crypt'}  eq "on") {

        $d="zpool create$opt2 -O encryption=$in{'select_str'} -f $in{'value_new'} $in{'autoselect_type'} $n";        # spaces are allowed

  #      use Expect;
        my $exp;   #->raw_pty(1);
        $exp = Expect->spawn("sudo $d") or die "Couldn't create zpool: $!\n";

        #$exp->log_stdout(1);             # echo off
        $exp->expect(3,
                [ 'passphrase' =>
                         sub {
                             $exp->send("$in{'value_crypt1pass'}\r");
                             print "Enter passphrase: ****<br>\n";
                             exp_continue;
                         }
                ] ,
                [ 'again' =>
                         sub {
                             $exp->send("$in{'value_crypt2pass'}\r");
                             print "Enter again: ****<br>\n";
                             exp_continue;
                         }
                ]
         );
         $exp->soft_close();
         sleep(2);



   } else {                     #without encryption


          # opt2=ashift
          if ($in{'autoselect_type'} =~/draid/)     {
             $draid=":$in{'value_datadisks'}"."d:"."$in{'value_spares'}"."s";
             if ($in{'value_children'} >0) { $draid.=":$in{'value_children'}"."c"; }

             #  zpool create tank draid[n]:4d:1s:11c /dev/sd[a-k]
             $d="zpool create $opt2 -f $in{'value_new'} $in{'autoselect_type'}$draid $n";        # spaces are allowed
          } else {
             $d="zpool create$opt$opt2$ver -f $in{'value_new'} $in{'autoselect_type'} $n";       # spaces are allowed
          }

          $d=~s/ +/ /g;       # double spaces=problem on proxmox

          print "$d<hr>";
          $i=&exe($d);   # return stderr

        ###############################################################

   }

   #something wrong?
   if ($i ne "") { print "$i or try another disk"; sleep(3); exit; }

   #overflow protection= basic reservation of 10%
   if ($in{'checkbox_res'}=~/on/i) {
        $r=&zfslib_get_property("available",$in{'value_new'});
        my $u=$r;
        $u=~s/[^A-Z]//g;
        $r=~s/[^0-9\.]//g;
        $r=$r/10;
        $r=sprintf("%0.2f", $r);
        $r.=$u;

#&mess("$r");
        # $do= &exe("/usr/sbin/zfs set reservation=$r \"$in{'value_new'}\"");      # not needed
        $do.=&exe("zfs set refreservation=$r $in{'value_new'}");               # fres counts immediatly

        if ($do=~/cannot share/) { $do=""; }      # share on freshly creared pool creates a cannot share message
        if ($do ne "") { print $do; sleep(2); }

   }

   #aclmode and aclinherit=passthrough
   $do=&exe("zfs set aclmode=passthrough $in{'value_new'}");
   $do.=&exe("zfs set aclinherit=passthrough $in{'value_new'}");

   print  &exe("zfs get aclinherit \"$in{'value_new'}\"");
   print  &exe("zfs get aclmode $in{'value_new'}");

   if ($do ne "") { print $do; sleep(2); }

   $in{'l2'}="";
   &reload;

   exit;

   #################################

}





###############################################
#end of my script, do not delete the line below
1;