#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($t,$r,@r,$p,@p,$w,@w,@fs,$s,@sf,@tf);  # declare all your variables as local or you will get errors

  # menue actions
  ###############
  # common lib
  require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/moverlib.pl";

  # list edit configurations
       if ($in{'autoselect_action'} eq "") { $in{'autoselect_action'}="-new ruleset for datamover fs-"; }

       $p[0]="-new ruleset to/from ZFS/regular folder-";

       $t="/var/web-gui/_log/datamover";
       @t=();
       &read_dir("$t","t",'.cfg');           # -> @t
       @t=sort(@t);
       foreach $t (@t) {
                if (!($t=~/\.cfg$/)) { next; }                #no rule
                push (@p,"$t");
       }

   #source Target
       $r=&exe("zfs list -t filesystem");
       @w=split(/\n/,$r);
       $fs[0]="-select a ZFS filesystem-";

       foreach $w (@w) {
       if ($w=~/^$zfs{'syspool'}\b/) { next; }
              $w=~s/\s.*//;
              if ($w eq "NAME") { next; }
              push (@fs,$w)
       }
       #&print_array(@fs);


  ###############################################
  # part 1: do function, if question is answered
  ##############################################

    if ($in{'submit_ok'} ne "submit") { $in{'answered'} =""; }  #not klicked on submit but on select

    if ($in{'answered'}) {      # question was answered
       &my_save;                # do it
    }



  ##############################
  # or create a form to ask user
  ##############################

  # read cfg
  #####
  #&print_hash(%in);

      if ($in{'autoselect_method'} eq "") {  $in{'autoselect_method'}="cpio"; }        #default

       if ($in{'autoselect_last_action'} ne "$in{'autoselect_action'}") {          # first call or modify
            $in{'autoselect_last_method'}="";
       }

       if (($in{'autoselect_action'} =~/\.cfg$/) && (-f "/var/web-gui/_log/datamover/$in{'autoselect_action'}"))  {

         if ($in{'autoselect_last_action'} ne "$in{'autoselect_action'}") {
              ##

              @t=();
              open (F,"/var/web-gui/_log/datamover/$in{'autoselect_action'}");
                 flock(F, LOCK_EX);
                 @t=<F>;
              close (F);

              #set %in
              foreach my $l (@t) {
                   @w=();
                   @w=split(/\t/,$l);
                   $in{$w[0]}=$w[1];
              }

              #debug
              #&print_array(@t);

           }
       }

       print "<h3>Datamover</h3>";
       &ask('begin');

       # rule and name
       $s=join(",",@p);
       &ask('autoselect_action','Action, new ruleset or edit',$s,$in{'autoselect_action'});
       &ask('hidden','autoselect_last_action',$in{'autoselect_action'});
       &ask('value_rname','Name of datamover ruleset </b><br>ex: mover_01 or video_older_60d<b>',$in{'value_rname'});

       # methods cpio, move, cmd optional copy, rsync, filesync as todo
       $t= "Only cpio, move preserve ACL, <br>";
       #$t.=Filesync does not delete and processes files only<br>";
       $t.="rsync cmd is in /var/web-gui/data/tools/rsync/rsync";
       &ask('autoselect_method',"Method: move, cpio or a cmd like rsync or sync.sh</b><br>$t<b>",'cpio,move,cmd',$in{'autoselect_method'});
       &ask('hidden','autoselect_last_method',$in{'autoselect_method'});


       # options mv
       if ($in{'autoselect_method'} eq "move") {
            if ($in{'value_opt_move'} eq "") { $in{'value_opt_move'}="-f"; }
            $t= " see <a href='https://docs.oracle.com/cd/E23824_01/html/821-1461/mv-1.html#scrolltoc' target='_blank'>man page mv</a><br>";
            $t.= "enter a space for none<br>force overwrite: -f";
            &ask('value_opt_move',"Options of /usr/bin/mv</b>$t<b>",,$in{'value_opt_move'});

            $s="dirmove,filemove + copy folder structure,filemove + del empty src folders";
            $t=" <br>move whole directory tree (ignore find name options)<br>move selected files but keep src folders<br>move selected files and remove empty source folders";
            &ask('select_opt2_move',"Options for move method</b>$t<b>",$s,$in{'select_opt2_move'});
       } else {
            &ask('hidden','value_opt_move',$in{'value_opt_move'});
            &ask('hidden','select_opt2_move',$in{'select_opt2_move'});
       }

       # options cp
       if ($in{'autoselect_method'} eq "copy") {
            if ($in{'value_opt_copy'} eq "") { $in{'value_opt_copy'}="-p"; }
            $t= " see <a href='https://docs.oracle.com/cd/E23824_01/html/821-1461/cp-1.html#scrolltoc' target='_blank'>man page cp</a><br>";
            $t.=" enter a space for none<br>preserve ACL and time: -p";
            &ask('value_opt_copy',"Options of /usr/bin/cp </b>$t<b>",,$in{'value_opt_copy'});
       } else {
            &ask('hidden','value_opt_cp',$in{'value_opt_cp'});
       }

       # options cpio
       if ($in{'autoselect_method'} eq "cpio") {
            if ($in{'value_opt_cpio'} eq "") { $in{'value_opt_cpio'}="-Ppumdav"; }
            $t=" see <a href=https://docs.oracle.com/cd/E23824_01/html/821-1461/cpio-1.html#REFMAN1cpio-1' target='_blank'>man page cp</a><br>";
            $t.= " enter a space for none<br>default: -Ppumdav";
            &ask('value_opt_cpio',"Options of /usr/bin/cpio </b>$t<b>",,$in{'value_opt_cpio'});
       } else {
            &ask('hidden','value_opt_cpio',$in{'value_opt_cpio'});
       }

       # options filesync
       if ($in{'autoselect_method'} eq "filesync") {
            if ($in{'value_opt_filesync'} eq "") { $in{'value_opt_filesync'}="-a -o src"; }
            $t="see <a href='https://docs.oracle.com/cd/E23824_01/html/821-1461/filesync-1.html#scrolltoc#scrolltoc' target='_blank'>man filesync</a><br>";
            $t.= "Preserve ACL: -a<br>1 way from: -o src | dst<br>2way: -f src | dst | old | new (2way sync ignores a source snap setting)";
            &ask('value_opt_filesync',"Options of /usr/bin/filesync </b>$t<b>",,$in{'value_opt_filesync'});
       } else {
            &ask('hidden','value_opt_filesync',$in{'value_opt_filesync'});
       }

       # options rsync
       if ($in{'autoselect_method'} eq "rsync") {
              if ($in{'value_opt_rsync'} eq "") { $in{'value_opt_rsync'}="-avzh"; }
              print "Options for rsync see <a href='https://www.samba.org/ftp/rsync/rsync.html' target='_blank'>man page rsync</a>, ";
              print "enter a space for none,<br>archiv/recursive mode, preserve time: -a<br>verbose: -v<br>compress data -z<br>human readable output: -h";
              &ask('value_opt_rsync','Options of /var/web-gui/data/tools/rsync/rsync',,$in{'value_opt_rsync'});
       } else {
              &ask('hidden','value_opt_rsync',$in{'value_opt_rsync'});
       }

       # options cmd
       if ($in{'autoselect_method'} eq "cmd") {
              $t= "<br>ex /path/mysync.sh<br>command or script ex rsync param or sync.sh";
              &ask('value_opt_cmd',"Command or Script opt with parameter</b>$t<b>",,$in{'value_opt_cmd'});
       } else {
              &ask('hidden','value_opt_cmd',$in{'value_opt_cmd'});
       }


       ####################
       # Source/destination
       ####################

       if ("copy,cpio,move,filesync,rsync"=~/$in{'autoselect_method'}/) {
          ##
          print "<br><br><h3>Source/ destination</h3><br>";

          # get source fs
          ###############
          $s="";
          $s=join(",",@fs);
          &ask('select_src_zfs','Source ZFS filesystem',$s,$in{'select_src_zfs'});

          # source regular folder
          &ask('value_src_folder','Regular folder below source ZFS Filesystem </b><br>ex /video<b>',$in{'value_src_folder'});
          print "<br><br>";

          # get destination fs
          ###############
          $s="";
          $s=join(",",@fs);
          &ask('select_dst_zfs','Destination ZFS filesystem <br></b>must be different from source tree!<b>',$s,$in{'select_dst_zfs'});

          # destination regular folder
          &ask('value_dst_folder','Regular folder below destination ZFS Filesystem </b><br>A missing subfolder will be created ex /backup<br>but not subsubfolders like /missing/backup<b>',$in{'value_dst_folder'});
          print "<br>";
       }
       #

       # GNU find
       ##########

       if ("copy,cpio,move,filesync"=~/$in{'autoselect_method'}/) {
         print "<br><h3>Find-Parameter (skip for all files recursively)</h3><br>";
         &ask('value_find','GNU find other parameter (optional), </b>see <a href="https://linux.die.net/man/1/find" target="_blank">find manpage</a><br>some important find parameter options see below<b>',$in{'value_find'});
       } else {
         &ask('hidden','value_find',$in{'value_find'});
       }

       #find -path/ipath
       if ("copy,cpio,move,filesync"=~/$in{'autoselect_method'}/) {
          $t="<br><span style='color:red'>set a */path in single quotes: -path '*/pathname/*'</span>";
          &ask('value_path',"opt find -path/-ipath <br></b>ipath is insensitive, ex: -ipath  \'*/video/*\' $t<b>",$in{'value_path'});
       } else {
         &ask('hidden','value_path',$in{'value_path'});
       }

       #find -name/-iname
       if ("copy,cpio,move"=~/$in{'autoselect_method'}/) {
          $t= 'iname is case insensitive ex -iname "*.html"<br>-name pic* -name *.mp4 gives relations<br>\( -name "*.css" -or -name "*.html" \) gives or relations<br>';
          $t.="<span style='color:red'>set a *filename in single quotes: -name '*char'</span>";
          &ask('value_fname',"opt find -name/-iname char<br></b>$t<b>",$in{'value_fname'});

       } else {
         &ask('hidden','value_fname',$in{'value_fname'});
       }

       #file age
       if ("copy,cpio,move"=~/$in{'autoselect_method'}/) {
          $t='-mtime +10 gets  all files older than 10 days<br>-mtime 10 gets all files that are 10 day old.<br>negative values like -mtime -5 means newer 5 days<br>-mtime +2 -mtime -5 gets files older two days and newer 5 days';
          &ask('value_age',"opt find files older days -mtime n</b><br>$t<b>",$in{'value_age'});
       } else {
          &ask('hidden','value_age',$in{'value_age'});
       }

       # file size
       if ("copy,cpio,move"=~/$in{'autoselect_method'}/) {
          $t= '-size +500k -size -2M <br>means file size must be between 500k and 2M<br>set size in k,M,G';
          &ask('value_size',"opt find based on file-size<br></b>ex -size +100k<br>$t<b>",$in{'value_size'});

       } else {
          &ask('hidden','value_size',$in{'value_size'})
       }

       #folder depth
       if ("copy,cpio,move"=~/$in{'autoselect_method'}/) {
          $t= 'recursive options -mindepth n -maxdepth n<br>-maxdepth 1 means find only in this folder';
          &ask('value_depth',"opt find based on folder depth</b><br>$t<b>",$in{'value_depth'});

       } else {
          &ask('hidden','value_depth',$in{'value_depth'});
       }

       #ab path
       if ("copy,cpio,move"=~/$in{'autoselect_method'}/) {
          $s="rel,abs";
          $t= 'use relative or absolute path for mover<br>';
          $t.="relative path creates destination files like ..dest/srcfolder/file";
          $t.="<br>abs path creates destination files like ..dest/pool/zfs/srcfolder/file";
          &ask('select_abspath',"opt use relative/absolute path for copy/move methods</b><br>$t<b>",$s,$in{'select_abspath'});

       } else {
          &ask('hidden','select_abspath',$in{'select_abspath'});
       }


       ## Snap management
       ##################

       if ($in{'autoselect_method'} ne "cmd") {                  # must care itself
          #
          print "<br><h3>Snap management</h3><br>";

          # snap as source
          if ($in{'autoselect_method'} ne "move") {
             ##
             $t="1";
             if (("filesync"=~/$in{'autoselect_method'}/) && ($in{'value_opt_filesync'}=~/f/)) { $t="0"; }  # filesync only one-way
             if ("cmd"=~/$in{'autoselect_method'}/) { $t="0"; }
             if ($t) {
                $s="yes,no";
                &ask('select_use_snap','Use a snap as data source',$s,$in{'select_use_snap'});
             } else {
                &ask('hidden','select_use_snap',$in{'select_use_snap'});
             }
          }

          # pre snap always possible
          if ("cpio,copy,move,rsync,filesync"=~/$in{'autoselect_method'}/) {
            $s="yes,no";
            &ask('select_src_snap','Create a source snap prior execution',$s,$in{'select_src_snap'});

            $s="no,yes";
            &ask('select_dst_snap','Create a destination snap prior execution',$s,$in{'select_dst_snap'});
          } else {
            &ask('hidden','select_src_snap',$in{'select_src_snap'});
            &ask('hidden','select_dst_snap',$in{'select_dst_snap'});
          }
       }
       print "<h3>&nbsp;</h3><br>";
       &ask('end');

       # header
       print "<script language='javascript'>document.getElementById('hl').innerHTML='Datamover between local pools'</script>\n";
       &log_end;
} #/ my_action



#############
sub my_save {
#############
# parse

  # debug
  #&print_hash(%in);

  my ($mess);

  # rulename
  $in{'value_rname'}=lc($in{'value_rname'});
  $in{'value_rname'}=~s/[^a-z0-9\-\_\.]//;

  $in{'value_rname'}=~s/ +$//;
  $in{'value_rname'}=~s/ +/_/g;
  if ($in{'value_rname'} eq "")  {  $mess.="Please enter a rulename<br>";  }

  if ($in{'autoselect_method'} ne "cmd") {
     #
     # source
     if (($in{'select_src_zfs'}=~/^-select/) || ($in{'select_src_zfs'} eq "")) {  $mess.="Please select a valid source fs<br>";  }
     if (($in{'select_dst_zfs'}=~/^-select/) || ($in{'select_dst_zfs'} eq "")) {  $mess.="Please select a valid destination fs<br>";  }

     # target must not contain source
     if ($in{'select_dst_zfs'}=~/$in{'select_src_zfs'}/) { $mess.="Target fs must not contain source fs<br>"; }

     # source must not contain target
     if ($in{'select_src_zfs'}=~/$in{'select_dst_zfs'}/) { $mess.="Source fs must not contain target fs<br>"; }

     # cmd
     #if ($in{'autoselect_method'} eq "cmd") {
     #      $t=$in{'value_opt_cmd'}; $t=~s/ .*//;    # command
     #      if (!($t=~/sync/)) { &mess("method cmd $t: command must contain sync in name"); }           # optional
     #}

     #method options
     if ($in{'value_opt_move'}=~/[^a-zA-Z0-9\-\_ ]/)     {  &mess("allowed char in options: 'a-zA-Z0-9-_ '"); }
     if ($in{'value_opt_copy'}=~/[^a-zA-Z0-9\-\_ ]/)     {  &mess("allowed char in options: 'a-zA-Z0-9-_ '"); }
     if ($in{'value_opt_cpio'}=~/[^a-zA-Z0-9\-\_ ]/)     {  &mess("allowed char in options: 'a-zA-Z0-9-_ '"); }
     if ($in{'value_opt_filesync'}=~/[^a-zA-Z0-9\-\_ ]/) {  &mess("allowed char in options: 'a-zA-Z0-9-_ '"); }
     if ($in{'value_opt_rsync'}=~/[^a-zA-Z0-9\-\_ ]/)    {  &mess("allowed char in options: 'a-zA-Z0-9-_ '"); }
     ## if ($in{'value_opt_cmd'}=~/[^a-zA-Z0-9\-\_\>|\ ]/)      {  &mess("allowed char in options: 'a-zA-Z0-9-_ '"); } #opt


      #
      #other find par
      if ($in{'value_find'} ne "") {
        if (!($in{'value_find'}=~/^\-\w+ /i))               {  &mess("other find parameter($in{'value_find'}\) must start with -parameter value"); }
      }

      #path find par
      if ($in{'value_path'} ne "") {
        if (!($in{'value_path'}=~/^\-i*path .+/))           {  &mess("path find parameter ($in{'value_path'}\) must start with -path char or -ipath char"); }
      }

      #name find par
      if ($in{'value_fname'} ne "") {
        if (!($in{'value_fname'}=~/^\-i*name .+/))           {  &mess("name find parameter ($in{'value_fname'}\) must start with -name char or -iname char"); }
      }

      #age find par
      if ($in{'value_age'} ne "") {
        if (!($in{'value_age'}=~/^\-mtime [\-+]*\d/))        {  &mess("mtime find parameter ($in{'value_age'}\) must start with -mtime n or -mtime -n"); }
      }

      #size find par
      if ($in{'value_size'} ne "") {
        if (!($in{'value_size'}=~/^\-size [\-+]*\d/))        {  &mess("size find parameter must ($in{'value_size'}\) start with -mtime n or -mtime -n"); }
      }

      #depth find par
      if ($in{'value_depth'} ne "") {
        if (!($in{'value_depth'}=~/^\-m..depth \d/))        {  &mess("depth find parameter ($in{'value_depth'}\) must start with -mindepth n or -maxdepth n"); }
      }
  } else {
      if (!($in{'value_opt_cmd'}=~/\w/))                    {  &mess("please enter a command");  }
  }

  # error
  if ($mess ne "") { &mess($mess); exit; }

  #ok, write

  my $file="/var/web-gui/_log/datamover/$in{'value_rname'}.cfg";
  print "create/update $file <br>";
  open (PF, ">$file");
     flock(PF, LOCK_EX);
     print PF "autoselect_method\t$in{'autoselect_method'}\t\n";
     print PF "value_rname\t$in{'value_rname'}\t\n";
     print PF "select_src_zfs\t$in{'select_src_zfs'}\t\n";
     print PF "select_dst_zfs\t$in{'select_dst_zfs'}\t\n";
     print PF "value_src_folder\t$in{'value_src_folder'}\t\n";
     print PF "value_dst_folder\t$in{'value_dst_folder'}\t\n";

     print PF "value_opt_move\t$in{'value_opt_move'}\t\n";
     print PF "select_opt2_move\t$in{'select_opt2_move'}\t\n";
     print PF "value_opt_copy\t$in{'value_opt_copy'}\t\n";
     print PF "value_opt_cpio\t$in{'value_opt_cpio'}\t\n";
     print PF "value_opt_filesync\t$in{'value_opt_filesync'}\t\n";
     print PF "value_opt_rsync\t$in{'value_opt_rsync'}\t\n";
     print PF "value_opt_cmd\t$in{'value_opt_cmd'}\t\n";

     print PF "value_find\t$in{'value_find'}\t\n";
     print PF "value_path\t$in{'value_path'}\t\n";
     print PF "value_fname\t$in{'value_fname'}\t\n";
     print PF "value_age\t$in{'value_age'}\t\n";
     print PF "value_size\t$in{'value_size'}\t\n";
     print PF "value_depth\t$in{'value_depth'}\t\n";
     print PF "select_abspath\t$in{'select_abspath'}\t\n";

     print PF "select_use_snap\t$in{'select_use_snap'}\t\n";
     print PF "select_src_snap\t$in{'select_src_snap'}\t\n";
     print PF "select_dst_snap\t$in{'select_dst_snap'}\t\n";
  close (PF);

  #&print_hash(%in);
  #

  $in{'l3'}="";
  &reload;

}



###############################################
#end of my script, do not delete the line below
1;