#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var,$v,$pool);  # declare all your variables as local or you will get errors

  # menue actions
  ###############


  ###############################################
  # part 1: do function, if question is answered
  ##############################################

    if (($in{'answered'}) && ($in{'submit_ok'} ne "")) {      # question was answered
       #&print_hash(%in);
       &my_function_01;          # do it
    }



  ##############################
  # or create a form to ask user
  ##############################

  print <<EoF;
<b>Raid-Z[1-3] is a new Open-ZFS feature to expand a Raid-Z vdev</b><hr>
Example: Expand a 3 disk raid-Z1 to a 4 disk raid-Z1<br><br>

Attention:<br>
This feature is quite new, for critical data wait some time prior using.<br>
A pool with an expanded raid-Z cannot be imported on systems that do not support this feature!<br><br>


EoF

# header
print "<script language='javascript'>\$('#hl').html('Raid-Z expansion on $in{'member'}')</script>\n";

if ($current{'on'}=~/Solaris/i) {

  &mess("Raid-Z expandion is currently not available on Illumos or Solaris");
}

#&print_hash(%zfs);
       if ($in{'autoselect_pool'} eq "") {
         $in{'autoselect_pool'}=$zfs{'allpools'};
         $in{'autoselect_pool'}=~s/\t.*//;                     # first pool
       }

       &ask('begin');
       $t=$zfs{'allpools'}; $t=~s/\t/,/g;
       &ask('autoselect_pool','Pool',$t,$in{'autoselect_pool'});

       $t="$in{'autoselect_pool'}\_vdevs";      #print_var($t);
       $v=$zfs{$t};

       #filter for raid-Z
       @t=split(/\t/,$v);
       $var="";
       foreach my $t (@t) {
           if ($t=~/raidz/) { $var.="$t,"; }
       }
       $var=~s/,$//;

       &ask('select_vdev','Raid-Z vdev',$var,$in{'select_vdev'});

       $t="$disk{'all_unused'}";  $t=~s/\t/,/g;
       &ask('select_disk','Add disk',$t);
       &ask('confirm','Expand',"Expand raidz vdev?");


       &log_end;
} #/ my_action



######################
sub my_function_01 {
#######################
   # zpool attach POOL raidzP-N NEW_DEVICE`,
   print "zpool attach $in{'autoselect_pool'} $in{'select_vdev'} $in{'select_disk'}<hr>";
   print &exe("zpool attach $in{'autoselect_pool'} $in{'select_vdev'} $in{'select_disk'}");
   sleep(3);
   $in{'l2'}="";
   &reload;
}


###############################################
#end of my script, do not delete the line below
1;