# os-lib.pl
####


return(1);
# os functions for napp-it    Copyright (c) 2010-2022 napp-it
# this lib is created automatically on a new os-folder if missing

##########
sub oslib {  #15.jan.2024
##########
}


################
sub oslib_status  {                 #hide:  -> print os status info in menue web-gui - about
###############
   my ($ant,$r,$t,$v,$h,$ok,$ref,@l,@w,$k);

   # on and hostname
   if ($current{'on'} eq "") {
         $current{'on'}=&exe('on');       # os name ex Solaris
   }

   return;      # win

   #defaults:

   # $h=&exe("hostname");         only remote
   chomp($h);

   #&print_hash(%sys);

   # $r=`ps axw | grep /var/web-gui/`;

    if (($in{'l1'} eq "") || ($in{'l1'} =~/00/)) {             # About
         print "<pre>\n\n";
    } else {
         print "<pre>";
    }

    #default
    if ($cfg{'select_lang'}=~/my|app/i) {   #iopstor
        print "$txt{'app_about_appliance'}\n\n";
        if ($sys{'edition'} ne "Pro")   {
           print "<b class='font_darkred'>    Your license key has expired. Please renew your license in menu Extensions &gt; Register</b>\n";
           if ($txt{'app_ex_dis'} eq "yes") {
              print "<b class='font_darkred'>    Your appliance is disabled</b>\n";
              &exe("svcadm disable smb/server");

              &exe("svcadm disable nfs/server");
              &exe("svcadm disable nfs/status");
              &exe("svcadm disable nfs/nlockmgr");
              &exe("svcadm disable nfs/mapid");
              &exe("svcadm disable nfs/rquota");
              &exe("svcadm disable nfs/cbd");

              &exe("svcadm disable svc:/network/iscsi/target:default");
              &exe("svcadm disable stmf");

           }
           return;
        }
    }

    #uptime
    print "    uptime           : ";
    $t=`uptime`;  $t=~s/^\s+//; $t=~s/\s +$//s;
    print "$t";

    #running on
    if ($txt{'app_about_show_running_on'}=~/\w+/) {
        #
        if (!($txt{'app_about_show_running_on'}=~/^ *no/)) {
           print "$txt{'app_about_show_running_on'}\n\n";
        }
     } else {
        $ant="    running on       : ";
        $ant.=`uname -a`; $ant=~s/\n|\r//gs;
        if (-f "/etc/release") {
                $t=&read_file("/etc/release");
                $t=~s/\n//gs; $t=~s/[^a-z0-9A-Z\_ \-]//gs;  $t=~s/ +/ /gs;  $t.="\n";
                $t=~s/^+//;
                $t=~s/Copyright.*//s;
                $ant.="<br>                      ".$t;
        }
        chomp $ant;
        print "$ant\n\n";
    }

    if (!($txt{'app_about_show_service_state'}=~/no/)) {
            #

            ## tasks
            print "    Job/ task server : ";
            if ($r=~/taskserver.sh/s) { print "running" } else { print "<font style='color:red'>missing</font>"; }
            print "\n";


            #autolock
            print "    Autolock agent   : ";
            #$t=`ps axw | grep agent_autolock.pl | grep -v grep`;
            if ($t=~/agent_autolock.pl/s) {
                 print "running";
            } else {
                 print "disabled";
            }

            if (-f "/var/web-gui/_log/autolock/_settings/autostart_enabled") {
               print " (autostart enabled)";
            }
            print "\n";

            # show napp-it status
            #print "    websocket server: ";
            #if ($r=~/socketserver.pl/s) { print "running" } else { print "<font style='color:red'>missing</font>"; }

            my @p=split(/\n/,$r);
            $t="";
            print "    Backgrnd-agents  : ";
            if (!($cfg{'ver'} =~/c|m/)) {
               $t="monitor extension required";

            } else {

               foreach my $p (@p) {
                   if (!($p=~/agent_stat|nappit/)) { next; }
                   if ($p=~/sudo|grep/)     { next; }

                   $p=~s/\'//; $p=~s/\'.*//;            # keep first parameter xx.pl 'cc' 'nn/vvs'
                   if ($p=~/stat\.pl|nappit/) {

                      $p=~s/nappit/appname/;            # due bundling
                      $p=~s/agent_stat.pl //;           # keep option like iostat
                      $p=~s/.*\///;
                      if ($p=~/ \d+$/) {                # remove timestamp
                        $p=~s/ \d+$//;
                      }

                      $t.="$p, ";
                   }
              }
            }
            $t=~s/, $//;
            print $t;

            $t="";
            print "\n    GUI accel-agents : ";
            if (!($cfg{'ver'} =~/\w/)) {
               $t="PRO required";
            } else {
              foreach my $p (@p) {
                   if (!($p=~/agent_acc/)) { next; }
                   if ($p=~/sudo|grep/)    { next; }

                   $p=~s/\'//; $p=~s/\'.*//;            # keep first parameter xx.pl 'cc' 'nn/vvs'
                   if ($p=~/acc\.pl/) {
                      $p=~s/agent_acc.pl //;            # keep option like format
                      $p=~s/.*\///;
                      if ($p=~/ \d+$/) {                # remove timestamp
                        $p=~s/ \d+$//;
                      }
                      $p=~s/_\D.*//;
                      $t.="$p, ";
                   }
              }
            }
            $t=~s/, $//;
            print $t;

            # z-raid
            print "\n    Z-RAID SSF agent : ";
            if ($r=~/agent_zraid_ssf/s) {
              print "running";
            } else {
              print "disabled";
            }

            # Keyserver
            print "\n    Keyserver        : ";
            if ($cfg{'select_key_server'} eq "yes") {
              print "enabled";
            } else {
              print "disabled";
            }

            #smb autolock
            $r=`ps axw | grep agent_autolock.pl | grep -v grep`;
            print "\n    Auto(un)lock     : ";
            if ($r=~/autolock/) {
                 print "enabled";
            } else {
                 print "disabled";
            }

            print "\n";
    }

    ################
    #show extensions
    ################

    $t=&getpd();
    print $t;
    if (!($t=~/\n/s)) { print "<br><br>"; }

    print "</pre>";


    #pool status and service only in osol..
    if (! ($sys{'auto_os'} =~/open|solaris|ill|omni/i))  { return; }


    ###################
    ## core services ##
    ###################

    $ant="<table style='width:1200px'><tr><td>";
    $ant.= "<br>\&nbsp;<b style='background-color:#dddddd'>Core Solarish Services:</b><pre>";

    # Solaris 11.4 bui
    #########
    if (($sys{'auto_os'}=~/Solaris/) && ($sys{'auto_os_ver'}>11.3)) {
       #
       $ant.="\n    bui dashboard    :  ";
       $r=`svcs | grep webui/server`;        $r=~s/ .*|\n//gs;
       if ($r eq "") {
            $r="<font style='color:#e9a47a'>disabled</font>";
       }
       if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x webui/server`;  $r.="</p>"; }
       $ant.=$r;

    }

    # auditd
    #########
    $ant.="\n    audit service    :  ";
    $r=`svcs | grep auditd`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x auditd`;  $r.="</p>"; }
    $ant.=$r;


    # Comstar iscsi
    #########
    $ant.="\n    comstar service  :  ";
    $r=`svcs | grep stmf`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x stmf`;  $r.="</p>"; }
    $ant.=$r;


    # Comstar fcoe target
    $ant.="\n    comstar fcoe     :  ";
    $r=`svcs | grep fcoe/target`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x fcoe/target`;  $r.="</p>"; }
    $ant.=$r;


    # Comstar ib target
    $ant.="\n    comstar ib srpt  :  ";
    $r=`svcs | grep ibsrp/target`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x ibsrp/target`;  $r.="</p>"; }
    $ant.=$r;


    # Comstar iscsi target
    $ant.="\n    comstar target   :  ";
    $r=`svcs | grep iscsi/target`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x ibsrp/target`;  $r.="</p>"; }
    $ant.=$r;

    # Comstar iscsi target
    $ant.="\n    comstar initiator:  ";
    $r=`svcs | grep iscsi/initiator`;        $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x ibsrp/target`;  $r.="</p>"; }
    $ant.=$r;


    # nfs
    #####
    $ant.="\n    nfs-server       :  ";
    $r=`svcs | grep nfs/server`;    $r=~s/ .*|\n//gs;
    $r=~s/\n/\n                 /gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }

    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x nfs/server`;  $r.="</p>"; }
    $ant.=$r;


    #smb
    ####
    $ant.="\n    smb/cifs-server  :  ";
    $r=`svcs | grep /smb/server`;
    $r=~s/\n/\n                 /gs;   $r=~s/ .*|\n//gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x smb/server`;  $r.="</p>"; }

    $ant.=$r;

    # ssh
    #####
    $ant.="\n    ssh-server       :  ";
    $r=`svcs | grep ssh`;     $r=~s/ .*|\n//gs;
    if ($r eq "") {
        $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
           $t=&read_file('/etc/ssh/sshd_config');
           $t.="\n";
       if ($t=~/\nPermitRootLogin +yes/is) {
            if ($t=~/\nAllowUsers root\n/s) {
              $r.=" - PermitRootLogin only: yes";
            } else {
              $r.=" - PermitRootLogin: yes";
            }
       } else { $r.=" - PermitRootLogin: no"; }
    }
    $ant.="$r";

    #firewall
    #########
    if ($sys{'auto_os'}=~/Solaris/i) {
         # pf
         $ant.="<br>\n    pf firewall      :  ";
         $r=`svcs | grep network/firewall:default`;     $r=~s/ .*|\n//gs;
         $t=`sudo /usr/sbin/modinfo -i pf`;  chomp($t);
         if ($t=~/\(\w/s) { $t=~s/.*\(/\(/s; } else { $t=""; }
         if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
         $ant.="$r $t";
    } else {
         #  ipf
         $ant.="<br>\n    ipf firewall     :  ";
         $r=`svcs | grep network/ipfilter`;     $r=~s/ .*|\n//gs;
         if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
         $ant.="$r";
    }


   ################
   # additional services
   ################
    $ant.= "</pre><br>\&nbsp;<b style='background-color:#dddddd'>Additional Services:</b><pre>";

    # Bonjour, included
    # service state
    $r=&exe("svcs -a | grep dns/multicast");
    if ($r =~/online/) {
         $r="online";

         # add services
         $t=`ps axw | grep dns-sd | grep -v grep`;
         if ($t=~/\d/s) { $r.=" - advertise";}
         if ($t=~/ 548 /s) { $r.= " afp,"; }
         if ($t=~/ 445 /s) { $r.= " smb"; }
         $r=~s/,$//;
    } else {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }
    $ant.="\n    bonjour/ osx     :  $r ";

    # iperf, included
    #####
    $ant.="\n    iperf-server     :  ";
    $r=`ps axw | grep iperf | grep -v grep`;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    }  else {
         $r="online";
    }
    $ant.=$r;

    #minidlna
    $ant.="\n    minidlna media   :  ";
    $r=`svcs | grep minidlna`;
    $r=~s/\n/\n                 /gs;   $r=~s/ .*|\n//gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x net-snmp`;  $r.="</p>"; }
    $ant.=$r;

    #minio
    $ant.="\n    minIO S3 cloud   :  ";
    $r=`ps axw | grep mini | grep -v grep`;
    if ($r=~/\d/) {
       $ant.="online";
    } else {
       $ant.="<font style='color:#e9a47a'>disabled</font>";
    }


    #snmp
    ####
    $ant.="\n    net-snmp         :  ";
    $r=`svcs | grep net-snmp`;
    $r=~s/\n/\n                 /gs;   $r=~s/ .*|\n//gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x net-snmp`;  $r.="</p>"; }
    $ant.=$r;

    #rsync, included
    ######
    $ant.="\n    rsync-server     :  ";
    $r=`svcs | grep rsyncd`;          $r=~s/ .*|\n//gs;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
       `sudo chmod 755 /var/web-gui/data/tools/rsync/rsync`;
       $t=`/var/web-gui/data/tools/rsync/rsync --version`;                  # show version
       $t=~s/\n.*//s;
       $r.=" $t";
    }
    $ant.=$r;

    #sendmail
    $ant.="\n    sendmail         :  ";
    $r=`svcs | grep smtp:sendmail`;    $r=~s/ .*|\n//gs;
    $r=~s/\n/\n                 /gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }

    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x nfs/server`;  $r.="</p>"; }
    $ant.=$r;

    $ant.="\n    sendmail client  :  ";
    $r=`svcs | grep sendmail-client`;    $r=~s/ .*|\n//gs;
    $r=~s/\n/\n                 /gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }

    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x nfs/server`;  $r.="</p>"; }
    $ant.=$r;

    #tftpd-hpa included
    $ant.="\n    tftp-server      :  ";
    $r=`ps axw | grep in.tftpd | grep -v grep`;
    if ($r eq "") {
         $r="<font style='color:#e9a47a'>disabled</font>";
    } else {
         $r=~s/.*in.tftpd/tftpd-hpa/;
         $r="online $r";
    }
    $ant.="$r";

   ################
   # other services
   ################
    $ant.= "</pre><br>\&nbsp;<b style='background-color:#dddddd'>Enabled User Services:</b><br>\&nbsp;without support<pre>";


    #afp, only when active
    ####
    $r=`svcs | grep netatalk`;        $r=~s/ .*|\n//gs;
    if ($r=~/\w/) {
      $ant.="\n    afp-server       :  ";

      #netatalk v3
      if ($sys{'netatalk3'} ne "") {

          if ($r eq "") { $r="<font style='color:#e9a47a'>disabled</font>"; }
          $r.=" netatalk V.3";

          if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x netatalk`;  $r.="</p>"; }

      } else {
          $r="<font style='color:#e9a47a'>netatalk3 not installed</font>";
      }
      $ant.=$r."\n";
    }


    # Apache only when active
    #########
    $r=`svcs | grep apache`;        $r=~s/ .*|\n//gs;
    if ($r=~/\w/) {
         #
         $ant.="    apache-server    :  ";

         if ($r eq "") {
              $r="<font style='color:#e9a47a'>disabled</font>";
         } else {
           # show Include info ############
           my $i;
           if ($sys{'auto_os_type'} eq "sol_s") {                       # Solaris
              $i=`cat /etc/apache2/2.2/httpd.conf`;
           } else {
              $i=`cat /opt/local/etc/httpd/httpd.conf`;                # ampo
           }
           @t=(); @t=split(/\n/,$i);
           $t="";
           foreach my $i (@t) {
             if ($i=~/^Include/) {
           $i=~s/.*\///;                                          #Include /opt/local/etc/httpd/httpd_owncloud.conf
           $i=~s/.conf//;
           $t.="$i, ";
        }
      }
      $t=~s/, $//;
      if ($t ne "") { $r.=" (Include $t)"; }
    }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x apache`;  $r.="</p>"; }
    $ant.=$r;
    }




    # dlna lms only when active
    #####
    $r=`svcs | grep lmsd`;
    if ($r=~/\w/) {
         #
         $ant.="\n    dlna lms         :  ";

         $r=~s/\n/\n                 /gs;
         if ($r eq "") {
              $r="<font style='color:#e9a47a'>disabled</font>";
         }  else {
              $r="online";
         }
         $ant.="Logitech Media Server $r";
    }


    # dlna mediatomb when active
    ############
    $r=`svcs | grep mediatomb`;
    $r=~s/ .*|\n//gs;
    if ($r=~/\w/) {
         #
         $ant.="\n    dlna mediatomb   :  ";


         if ($r eq "") { $r="<font style='color:#e9a47a'>disabled</font>"; }
         $ant.=$r;
    }

    # ftp when active
    #####
    $r=`svcs | grep proftpd`;          $r=~s/ .*|\n//gs;
    if ($r=~/\w/) {
         #
         $ant.="\n    ftp-server       :  ";

         if ($r eq "") {
              $r="<font style='color:#e9a47a'>disabled</font>";
         }  else {
              $r="ProFTPD $r";
         }
         $ant.=$r;
    }


    #mysql when active
    ######
    $r=`svcs | grep mysql`;
    if ($r=~/\w/) {
         #
         $ant.="\n    mysql-server     :  ";

         $r=~s/\n/\n                 /gs;
         $r=~s/ +.*//s;
         if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
         if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x mysql`;  $r.="</p>"; }
         $ant.=$r;
     }


    # Redis when active
    ############
    $r=`svcs | grep redis`;
    if ($r=~/\w/) {
         #
         $ant.="\n    redis database   :  ";
         $r=~s/ .*|\n//gs;
         if ($r eq "") { $r="<font style='color:#e9a47a'>disabled</font>"; }
         $ant.=$r;
    }

    #mate vnc (Hipster, opt)
    if (-f "/etc/lightdm/lightdm.conf") {
       #
       $ant.="\n    vnc server mate  :  ";
       if (!(-f "/etc/lightdm/lightdm.conf")) {
          $ant.="not available";
       } else {
          $r=`cat /etc/lightdm/lightdm.conf`;
          $r=~s/.*\[VNCServer\]//s;  # VNC area
          $r=~s/\[.*//s;            # other area
          if ($r=~/\nenabled\=true/s) {
              $ant.="enabled";
              $r=~s/.*listen\-address\=//s;
              $r=~s/\n.*//s;
              if ($r ne "") { $ant.=", listen $r"; }
          } else {
              $ant.="<font style='color:#e9a47a'>disabled</font>";
          }
       }
    }

    #zones (user vm)
    ####
    $ant.="\n    zones service    :  ";
    $r=`svcs | grep system/zones:default`;
    $r=~s/\n/\n                 /gs;   $r=~s/ .*|\n//gs;
    if ($r eq "") {$r="<font style='color:#e9a47a'>disabled</font>"; }
    if ($r=~/maintenance/) { $r.="<p style='margin-left: 140px'>"; $r.=`svcs -x system/zones:default`;  $r.="</p>"; }

    $ant.="$r (Linux container or Solaris zones)";

    print "$ant\n\n</pre>";
    print "</td><td style='padding-left:50px;padding-top:0'>";


    #######################
    # iostat realtime graph
    #######################
    print '<br><canvas id="cvs2" width="600" height="300">[No canvas support]</canvas>';
    print '<canvas id="cvs1" width="600" height="300">[No canvas support]</canvas>';

    print <<EoF;
<!-- iostat script -->
<script type="text/javascript">

    // other stat
    rgraph_arczilstat=function(data) {}
    rgraph_netstat=function(data) {}
    rgraph_cpustat=function(data) {}
    rgraph_servicestat=function(data) {}

    // iostat
    rgraph_iostat=function(data) {

           // reset or old values keep visible
           var canvas = document.getElementById('cvs1');
           RGraph.Reset(canvas);

           canvas = document.getElementById('cvs2');
           RGraph.Reset(canvas);

           // prepare data
           var adata=data.split(";");            // iostat; time; x-unit; devicenumbers; labels1; key1 ;diskdata1(io); key2; diskdata2(busy/wait); cpubusy ; height

           \$("#cvs1").height(300);              // set height ??
           \$("#cvs1").width(600);               // set height ??

           var alabels1=adata[2].split(",");     // labels1 (y-values=sd1,sd2)
           var alabels2=adata[6].split(",");     // labels1 (y-values=sd1,sd2)
           var n=alabels1.length;                 // number of devices

           var akeys1=adata[3].split(",");       // keys1  (x values=read,write)
           var akeys2=adata[7].split(",");       // keys2

           var data1=adata[4].split(":");         // data1
           var data2=adata[8].split(":");         // data2

           var adata1=new Array(n);              // array of data1 (array of arrays)
           var adata2=new Array(n);              // array of data2 diskdatas (array of arrays)

           var busy=adata[9];                    // busy
           var avbusy=adata[10];                 // busy 10s

           // diskdata: build array of arrays
           for (var i = 0; i < n; i++ ) {
                adata1[i] = data1[i].split(",");
           }

           //alert(alabels);

           // disk_avrg_data: build array of arrays
           for (var i = 0; i < n; i++ ) {
                adata2[i] = data2[i].split(",");
           }




           // wait, await, w%, b%
           var hbar2 = new RGraph.HBar('cvs2', adata2 )
               .Set('title', 'iostat: wait/ w%/ b%  //CPU busy/10s_avrg = ' +busy +'%/ ' +avbusy +'%')
               .Set('title.size', '8')
               .Set('title.vpos', 0.5)
               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               //.Set('shadow', true)
               .Set('vmargin', 5)
               .Set('xmax', 100)        // x-range max
               .Set('xmin', 0)          // x-range min 0
               .Set('labels', alabels2)
               .Set('key', akeys2 )
               .Set('key.position', 'gutter')

               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['red','#fcb39d','blue','green'])
               .Set('colors', ['Gradient(#fa8973:red)',
                               'Gradient(#fcb39d:#fcb39d)',
                               'Gradient(#bbc8fe:blue)',
                               'Gradient(#7ae472:green)'
                               ])
                .Draw(hbar2);
    }
</script>


EoF

    print "</td></tr></table>";

    # move oldkeys from /var/web-gui/data/napp-it/_log/appliance.log to /var/web-gui/data/napp-it/_log/appliance.oldkey
    # my (@new,@old,@bak,$date,$diff);


}

# end of file
1;